/**
 * Names of events for widgets.
 * @namespace   widget
 * @memberOf    module:events
 * @implements  {events}
 * 
 * @property {String} WidgetBeforeInlineEditMoveRow  - Triggered before changing to inLineEdit mode.
 * @property {String} WidgetBeforeMoveRow            - Triggered before changing the current row.
 * @property {String} WidgetAfterMoveRow             - Triggered after changing the current row.
 * @property {String} WidgetBeforeNewRow             - Triggered before creating a new row.
 * @property {String} WidgetNewRow                 - Triggered when creating a new row.
 * @property {String} WidgetOnEnter                  - Triggered when entering a widget.
 * @property {String} WidgetOnEnterOnce              - Triggered when entering a widget for the first time.
 * @property {String} WidgetOnEnterTab               - Triggered when entering a new tab.
 * @property {String} WidgetOnSync                   - Triggered when synchronizing the widget.
 * @property {String} WidgetBeforeSelectRow          - Triggered before selecting a row.
 * @property {String} WidgetAfterSelectRow           - Triggered after selecting a row.
 * @property {String} WidgetBeforeUnselectRow        - Triggered before unselecting a row.
 * @property {String} WidgetAfterUnselectRow         - Triggered after unselecting a row.
 * @property {String} WidgetOnCancel                 - Triggered when canceling an edition.
 * @property {String} WidgetOnSave                   - Triggered when saving an edition.
 * @property {String} WidgetBeforeSelectAll          - Triggered before selecting all rows.
 * @property {String} WidgetAfterSelectAll           - Triggered after selecting all rows.
 * @property {String} WidgetBeforeUnselectAll        - Triggered before unselecting all rows.
 * @property {String} WidgetAfterUnselectAll         - Triggered after unselecting all rows.
 * @property {String} WidgetOnInitDataSource           - Triggered when creating the datasource.
 * @property {String} WidgetAfterLoadDataSource      - Triggered after loading the datasource.
 * @property {String} WidgetAfterLoadDataSourceError - Triggered after loading the datasource, when it throws error.
 * @property {String} WidgetPopUpOnCancel            - Triggered when closing a popup.
 * @property {String} WidgetOnActivate               - Triggered when widget is activated.
 * @property {String} WidgetOnDeactivate             - Triggered when widget is deactivated.
 * @property {String} WidgetOnDateClick                - Triggered when widget date is clicked on a calendar.
 * @property {String} WidgetOnMonthClick               - Triggered when widget month is clicked on a calendar.
 * @property {String} WidgetOnYearClick                - Triggered when widget year is clicked on a calendar.
 * @property {String} WidgetOnDashboardClick         - Triggered when clicking on the dashboard.
 * @property {String} WidgetOnDashboardConfigClick   - Triggered when clicking on the dashboard configuration.
 * @property {String} WidgetOnSaveInlineEdit         - Triggered when saving an inline edition.
 * @property {String} WidgetOnCancelInlineEdit       - Triggered when canceling an inline edition.
 * @property {String} WidgetOnSaveRelations          - Triggered when saving a relation.
 * @property {String} WidgetOnOpenDetail             - Triggered when opening the widget detail.
 * @property {String} WidgetOnCloseSwipe             - Triggered when closing swipe.
 * @property {String} WidgetOnNewColor               - Triggered when changing the color.
 * @property {String} WidgetOnChangeMonth            - Triggered when changing the month on a calendar.
 * @property {String} WidgetOnChangeYear             - Triggered when changing the year on a calendar.
 * @property {String} WidgetOnChangeDecade           - Triggered when changing the decade on a calendar.
 */