# Contributing
When contributing to this repository first, you should install all the dependencies and build the evironment.
## Install dependencies

To install all dependencies run the steps bellow:

1. `npm install`, to install all node dependencies (listed on package.json)
2. `bower install`, to instal all bower dependencies (listed on bower.json)
3. `composer install` in example/backend`

Now is necessary to config your environment. Go to file example/config and create the file development.json. There you should config as the example bellow:
```js
{
    "APP_VERSION": "<YOUR_APP_VERSION>",
    "FRAMEWORK_PATH": "<YOUR_BOWER_PATH>" + "/zeedhi-frontend",
    "BACKEND_PATH": "../backend/service/index.php",
    "ZH_DESCRIPTION_PATH": "<YOUR_BOWER_PATH>" + "/zh-description",
    "SELECT_AUTOCOMPLETE_PATH": "../..",
    "DEPENDENCIES_PATH": "<YOUR_BOWER_PATH>",
    "SELENIUM_ADDRESS": "<YOUR_SELENIUM_ADRESS>",
    "SELECT_AUTOCOMPLETE_URL": "<THE_SELECT_AUTOCOMPLETE_FRONTEND_URL>"
}
```

And then run `grunt build`.

If some example make necessary, go to: http://mateuslopes.zeedhi.com/workfolder/zh-select-autocomplete/example/config/development.json

## Tests
### Functional
To run our tests we use:
 * ZeedhiFunctionalTestsApi - http://code.zeedhi.com/pauloneto/functionaltestsapi/blob/master/README.md
 * SeleniumServerStandalone - http://www.seleniumhq.org/download/

#### Creating
When create any test, it should be in:
 * tests/functional/specs

Respecting the following patterns.

#### Running
To run our functional tests:
1. Run your selenium-server-standalone-X.X.X.jar
2. Run `npm run tests`

## Coding

### Model
 * Variables and Functions are always in camelCase
 * The only exception are const variables that stays in CAPS

### Changes
* When made any changes in
 * src/controllers
 * src/directives

 Run ```grunt``` to insert you changes to the javascript used in the project, dist/zh-select-autocomplete;
* Changes made in 'templates/' run ```grunt copy```


### Documentation

We use JsDoc for documetation:
* http://usejsdoc.org/

#### Documentation for functions

Is indispensable for functions the tags:
 * @description
 * @public | @private

And, if the function have:
 * @param, following the model:
    * @param {type} paramName - paramDescription
 * @return, following the model:
    * @return {type} returnDescription

Note that if is an typed array or promise the model is:
 * Array.< String >
 * Promise.< Boolean >