/**
 * Controller
 **/
function ZmartDashboardCardController($scope, maskEngine, ZhUtil){
    
    this.getTitle = function(titleNumber){
        var result;
        if (titleNumber) {
            $scope.widget['cardTitle' + titleNumber]; 
        } else {
            result = $scope.widget.cardTitle; 
        }
        return result;
    };
    
    this.getValue = function(valueNumber){
        var widget = $scope.widget;
        var field, cardMask;
        var value;
        
        var dataSourceOnWidget = isThereDataSourceDataOnWidget(widget);
        
        field = valueNumber ? widget['cardValue' + valueNumber] : widget.cardValue;
        cardMask = valueNumber ? widget['cardMask' + valueNumber] : widget.cardMask;
        value = (dataSourceOnWidget && dataSourceOnWidget.length > 0) ? widget.dataSource.data[0][field] : widget.chartSeries[0].cardValue;
        
        widget.value = value;
        
        if (cardMask) {
            value = applyMask(cardMask, value);
        }
        
        return value;
    };
    
    function isThereDataSourceDataOnWidget(widget){
        return widget.dataSource && widget.dataSource.data;
    }
    
    this.onCardClick = function(){
        if($scope.widget.afterMoveRow){
            if($scope.widget.dataSource.data && $scope.widget.dataSource.data[0]){
                $scope.widget.currentRow = $scope.widget.dataSource.data[0];
            }
            $scope.widget.afterMoveRow();
        }
    };
    
    function applyMask(cardMask, value) {
        var mask = {
            "params": {}
        };
        mask.params.precision = 2;
        mask.type = cardMask;
        return Util.applyMask(value, mask, maskEngine, ZhUtil);
    }
}