(function() {

    var ZeedhiDirectives = angular.module('ZeedhiDirectives');
    ZeedhiDirectives.directive('zmartAccordionItem', zmartAccordionItem);

    function zmartAccordionItem($timeout) {
        var widget;

        function calcElementHeight(elements) {
            elements.each(function(index, el) {
                el = $(el);
                var container = el.closest('.container');
                var accordionItemCount = widget.widgets.length;
                var openedHeight = height = container.height() / accordionItemCount;
                var item = el[0].item;

                if (item && item.opened) {
                    var dashboard = el.find('.zmart-accordion-item-dashboard');

                    openedHeight = height + dashboard.height(); // padding: 5px;
                }
                el.animate({height: openedHeight}, 300);

                if (item && item.opened && (!item.widgets || item.widgets.length === 0)) {
                    el.find('.zmart-accordion-item-header').animate({height: openedHeight}, 300);
                } else {
                    el.find('.zmart-accordion-item-header').animate({height: height}, 300);
                }
            });
        }

        $(window).on('resize.zmart-accordion', function() {
            $timeout(function() {
                calcElementHeight($('.zmart-accordion-item'));
            },100);
        });

        var linkFunction = function(theScope, theElement, attrs) {
            var scope = theScope;
            var element = theElement;
            widget = theScope.widget;

            scope.$on('zh-scrolled-finished', function(events, container) {
                if (container[0] == element.closest('.container')[0]) {
                    calcElementHeight(element);
                }
            });

            function initializeItem() {
                var item = widget.widgets[parseInt(attrs.itemIndex)];
                item.element = element;
                item.calcElementHeight = function() {
                    calcElementHeight(this.element);
                };
                element[0].item = item;
            }
            initializeItem();
        };

        return {
            restrict: 'A',
            link: linkFunction
        };
    }
})();