<?php

namespace Teknisa\Model\Teknisa\Repositories;

class OmProdutoOrgElemento extends \Doctrine\ORM\EntityRepository {
    public function getOrgElements($productId, $elementProductOrg) {
        $query = <<<SQL
        SELECT PE.ID, PE.LABEL, PE.UNIQUE_ID,
               PE.NRPRODUTO_ID, PE.PARENT_ID, PE.NRORDEM,
               TO_CHAR(OE.DTVALIDADE, 'DD/MM/YYYY') AS DTVALIDADE,
               :elementProductOrg AS NRPRODUTO_ORG_ID,
               DECODE(OE.ID, NULL, 'N', 'S') AS ATIVO
          FROM OM_PRODUTO_ELEMENTO PE
     LEFT JOIN OM_PRODUTO_ORG_ELEMENTO OE ON OE.NRPRODUTO_ELEMENTO_ID = PE.ID
                                         AND NRPRODUTO_ORG_ID = :elementProductOrg
         WHERE PE.NRPRODUTO_ID = :productId
      ORDER BY PE.NRORDEM
SQL;
        $params = array(
            'productId' => $productId,
            'elementProductOrg' => $elementProductOrg
        );

        $elements = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return $elements;
    }

    public function getChildrenOrgElements($id) {
        $query = <<<SQL

        SELECT ELEM.ID
          FROM OM_PRODUTO_ELEMENTO ELEM
 	     START WITH ELEM.ID = :id
       CONNECT BY PRIOR ELEM.ID = ELEM.PARENT_ID
SQL;

        $params = array(
            'id' => $id
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}