// FILE: ./assets/js/util/Messages.js
function AclMessages() {
    /* + ----------------------------------- +
     * | Confirm messages                    |
     * + ----------------------------------- + */
    this.CON_DEL_PROFILE = 'Are you sure you want delete this profile?';
    this.CON_DEL_PROFILE_OPERATORS = 'Are you sure you want delete that operators related with this access profile?';
    this.CON_CHEN_ACCESS_PROFILE = 'Are you sure you want change the access control?';
    this.CON_DEL_OPERATOR = 'Do you want to delete the selected operator?';
    this.CON_DEL_BRANCH = 'Do you want to delete the selected branch?';
    this.CON_DEL_ORGANIZATION = 'Do you want to delete the selected organization?';

    /* + ----------------------------------- +
     * | Error messages                    |
     * + ----------------------------------- + */
    this.ERR_DEL_PROFILE = 'Error at try delete profile. Error: ';
    this.ERR_SAV_PROFILE = 'Error at try save profile. Error: ';
    this.ERR_SAV_PROFILE_OPERATORS = 'Fail at try relate the operators at this profile.';

    /* + ----------------------------------- +
     * | Alert messages                    |
     * + ----------------------------------- + */
    this.ALE_FILL_REQ_FIELD = 'The required fields must be filled.';
    this.ALE_PASSWORD_NOT_MATCH = 'Passwords do not match.';
    this.ALE_PASSWORD_INVALID_LENGTH = 'Password must contain between 6 and 20 characters.';
    this.ALE_NEW_PASSWORD_EQUAL_OLD = 'New password can not be the same as old';
    this.ALE_IMAGE_REQUIRED_FIELD = 'Choose a profile picture';
    this.ALE_PERMISSION_ORGANIZATION = 'You can only manipulate organizations in which you are inserted.';
    this.ALE_MIN_LENGTH_OPERATOR_CODE = 'O campo "Código" deve conter 12 caracteres.';

    /* + ----------------------------------- +
     * | Success messages                    |
     * + ----------------------------------- + */
    this.SUC_DEL_OPERATOR = 'Operator deleted successfully.';
    this.SUC_SAVE_OPERATOR = 'Operator save successfully.';
    this.SUC_DELETE_ACCESS_PROFILE = 'Access profile deleted successfully.';
    this.SUC_SAVE_ACCESS_PROFILE = 'Access profile saved successfully.';
    this.SUC_SAVE_RELATED_BRANCH = 'Branch saved successfully.';
    this.SUC_SAVE_RELATED_ORGANIZATION = 'Organization saved successfully.';
    this.SUC_SAVE_PASSWORD = 'Password changed successfully.';
    this.SUC_ACCESS_PROFILE_ACTIVATED = 'Access control activated successfully!';
    this.SUC_ACCESS_PROFILE_DISABLED = 'Access control disabled successfully!';
    this.SUC_DELETE_RELATED_BRANCH = 'Branch Deleted successfully.';
    this.SUC_DELETE_RELATED_ORGANIZATION = 'Organization Deleted successfully.';
}

Configuration(function(ContextRegister) {
    ContextRegister.register('AclMessages', AclMessages);
});

// FILE: ./assets/js/util/UpdateCustomIndexItems.js
var BASE_DIR_THEME        = 'bower_components/zeedhi-frontend/assets/css/styles/';
var BASE_DIR_FILTER_THEME = 'bower_components/zh-preferences/dist/style/colors/';
var BASE_DIR_AUTOCOMPLETE = 'bower_components/zh-select-autocomplete/dist/style/colors/';
var BASE_DIR_IMAGES       = '../../../mobile/assets/images/';
var STYLESHEET_TYPE       = 'stylesheet';
var SHORTCUT_ICON_TYPE    = 'shortcut icon';

var addLinkTagInHead = function(href, type) {
    var lnk = document.createElement('link');
    lnk.setAttribute('rel', type );
    if(type == STYLESHEET_TYPE) {
        lnk.setAttribute('type', "text/css");
    }
    lnk.setAttribute('href', href);
    document.getElementsByTagName("head").item(0).appendChild(lnk);
};

//Update Theme
var style = window.cssStyle || 'inflightor';
var href = BASE_DIR_THEME + 'styles-' + style + '.css';
addLinkTagInHead(href, STYLESHEET_TYPE);

//Update Filter Theme
var filterHref = BASE_DIR_FILTER_THEME + 'styles-' + style + '.css';
addLinkTagInHead(filterHref, STYLESHEET_TYPE);

//Update Select Autocomplete Theme
var autocompleteHref = BASE_DIR_AUTOCOMPLETE + 'styles-' + style + '.css';
addLinkTagInHead(autocompleteHref, STYLESHEET_TYPE);

//Update Favicon
var favicon = BASE_DIR_IMAGES + 'favicon.png';
addLinkTagInHead(favicon, SHORTCUT_ICON_TYPE);

//Remove Splash
$("<style> .splash { display: none !important; </style>").appendTo("head");

// FILE: ./assets/js/util/Utilities.js
function ACLUtilities(restEngine, templateManager, ZHPromise, ScreenService, ZhPreferences,
                      ZhFilterPreferences, General, requestDataSourceEngine, AclMessages)
{
    var self = this;

    this.callRestEngine = function (dataSource, requestType, requestValue) {
        var defer = ZHPromise.defer();
        var params = {};

        switch (requestType) {
            case "Row":
                params = {
                    "requestType": "Row",
                    "row": requestValue
                };
                break;
            case "DataSet":
                params = {
                    "requestType": "DataSet",
                    "dataset": requestValue
                };
                break;
            case "FilterData":
                params = {
                    "requestType": "FilterData",
                    "filter": requestValue
                };
                break;
            default:
                return defer.reject("Erro na passagem de parâmetros para a requisição. O valor para requestType deve ser 'Row', 'DataSet' ou 'FilterData'.");
        }

        return restEngine.request(dataSource, params);
    };

    this.changeWidgetAcessibility = function (widgets, enabled) {
        widgets.forEach(function (widget) {
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };

    this.formWidgetSwitchTemplate = function (widget) {
        if ((widget.template != "widget/form.html") && (widget.template != "widget/form-view.html")) return false;

        if (!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if (!widget.templateToView) widget.templateToView = "widget/form-view.html";

        if (widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if (widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    this.widgetSave = function (widget) {
        var deferred = ZHPromise.defer();

        if (widget.isValid()) {
            widget.currentRow.changed = true;

            if (!widget.currentRow.__is_new)
                widget.currentRow.__is_new = false;
            else if (widget.paramsNewCode && widget.paramsNewCode.__is_new_code) {
                widget.currentRow.__using_unit = widget.paramsNewCode.__using_unit || false;
                widget.currentRow.__new_code_pk = widget.paramsNewCode.__new_code_pk;
                widget.currentRow.__table_pk = widget.paramsNewCode.__table_pk;
                widget.currentRow.__new_code_length = widget.paramsNewCode.__new_code_length || 5;
                widget.currentRow.__cast_number = widget.paramsNewCode.__cast_number || false;
            }

            widget.saveRow().then(function (response) {
                widget.currentRow.changed = false;
                delete widget.backupRow;

                if (self.formWidgetSwitchTemplate(widget) && widget.parent) {
                    widget.view();

                    var widgets = widget.parent.widgets;
                    self.changeWidgetAcessibility(widgets.concat(widget.parent), true);
                } else {
                    if (widget.currentRow.__is_new) {
                        ScreenService.closeSwipe();
                        widget.list();
                    } else widget.view();

                    self.changeWidgetAcessibility(widget.widgets, true);
                }

                if (widget.currentRow.__is_new) widget.currentRow.__is_new = false;
                else widget.reload();

                deferred.resolve(response);
            }.bind(this), function (error) {
                var errorMessage = 'Timeout';

                if (error.data) errorMessage = error.data.error;

                ScreenService.showMessage(errorMessage);
                deferred.reject(errorMessage);
            });
        } else deferred.reject("Preencha todos os campos corretamente!");

        return deferred;
    };

    this.widgetEdit = function (widget) {
        if (!widget.editing) {
            //Trata a edição de uma widget filha do tipo form
            if (self.formWidgetSwitchTemplate(widget) && widget.parent) {
                var widgetsToDeactivate = widget.parent.widgets;

                self.changeWidgetAcessibility(
                    widgetsToDeactivate.filter(function (subwidget) {
                        return subwidget.name != widget.name;
                    }).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
                    false);
            } else //trata a edição dos demais casos
                self.changeWidgetAcessibility(widget.widgets, false);

            //propriedades a serem ignoradas na criação do backup
            var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders",
                               "__index", "__isSelected", "__notSelectable", "$$hashKey"];

            //faz backup da currentRow para permitir a recuperação dos dados
            widget.backupRow = Util.clone(widget.currentRow, ignoredKeys);
            widget.edit();
            return true;
        } else return false;
    };
    
    /*
	 * Procedimento que cancela o formulário de uma
	 * widget, seja este de inserção ou de edição, e
	 * desbloqueia as demais widgets.
	 *
	 * @param object widget
	 */
	this.widgetCancelForm = function (widget) {
		//trata o cancelamento de uma widget filha do tipo form
		if (this.formWidgetSwitchTemplate(widget) && widget.parent) {
			var widgets = widget.parent.widgets;

			this.changeWidgetAcessibility(widgets.concat(widget.parent), true);
		} else //trata o cancelamento dos demais casos
			this.changeWidgetAcessibility(widget.widgets, true);

		//caso a widget estiver em modo de inserção, remove a row e fecha o swipe
		if (widget.currentRow.__is_new) {
			var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
			if (indexOfCurrentRow !== -1) {
				widget.dataSource.data.pop();
			}

			widget.list();

			ScreenService.closeSwipe();
		} else { //caso a widget estiver em modo de edição, recupera o backup e entra no modo de visualização
			Object.keys(widget.backupRow).forEach(function (key) {
				widget.currentRow[key] = widget.backupRow[key];
			}); //copia dados coluna por coluna para não perder referência do objeto da currentRow
			widget.view();
		}
	};
	
	this.startFilter = function(widget, currentRow){
        ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(result) {
            if (result) {
                ZhFilterPreferences.openFilterWidget(widget, currentRow);
            }
        });
    };

    this.applyDefaultFilterOnEnter = function(widget) {
        var time = 500;
        return setTimeout(function() {
            self.setDefaultFilterOnEnter(widget);
        }, time);
    };

    this.setDefaultFilterOnEnter = function(widget){
        if (widget.inListMode()) {
            if (self.isAppliedFilter(widget)) {
                widget.reload();
            } else if (widget.currentRowDefaultFilter) {
                self.startFilter(widget, widget.currentRowDefaultFilter);
            } else {
                self.startFilter(widget, widget.currentRow);
            }
        }
    };
    
    this.isAppliedFilter = function(widget){
        return !!widget.aclAppliedFilter;
    };

    this.setFilterInit = function (widget) {
        widget.aclAppliedFilter = true;
    };

    this.initializeFieldSelectAutocomplete = function(field){
        field.initializeField();
    };
    
    this.genericCancelEvent = function(widget, primaryProprety) {
        primaryProprety = primaryProprety ? primaryProprety :"ID";
        var primaryValue = widget.currentRow[primaryProprety];
        if (widget.currentRow.__is_new) {
            ScreenService.closeSwipe();
            widget.reload();
        } else {
            widget.reload().then(function(){
                widget.view();
                return widget.dataSource.data.some(function (row) {
                    if (row[primaryProprety] == primaryValue) {
                        widget.currentRow = row;
                        return true;
                    }
                });
            });
        }
        templateManager.updateTemplate();
    };
    
    this.validateCPF = function (cpf) {
        if(cpf && !General.validateCPF(cpf)){
            ScreenService.showMessage("Número de CPF inválido.");
            return false;
        }
        return true;
    };
    
    this.checkRequirements = function(widget) {
        if(!widget.isValid()) {
            ScreenService.showMessage('Preencha todos os campos marcados com asterisco!');
            return false;
        }
        return true;
    };
    
    this.getRowInDataSource = function (dataSource, primaryProperty, primaryValue) {
        var currentRow = null;
        dataSource.data.some(function (row) {
            if (row[primaryProperty] == primaryValue) {
                currentRow = row;
                return true;
            }
        });
        return currentRow;
    };
    
    this.setDataSourceAfterSave = function(widget, filter, valueIndex){
        var widgetDataSource = widget.dataSource.data;
        return requestDataSourceEngine.getDataSource(widget.dataSource.name, filter).then(function (response) {
            var dataset = response.dataset[widget.dataSource.name.split('/')[1]];
            var isRow = widgetDataSource.some(function(data, index){
                if(data[valueIndex] == dataset[0][valueIndex]){
                    widgetDataSource[index] = dataset[0];
                    return true;
                }
            });
            if(!isRow) {
                widgetDataSource.push(dataset[0]);
            }
            return dataset[0];
        });
    };
    
    this.genericDeleteEvent = function (widget){
        return widget.dataSource.remove([widget.currentRow]).then(function(data){
            return ScreenService.closeSwipe().then(function(){
                return widget.reload();
            });
        });
    };
    
    this.getOnlyNumberInString = function(string){
        if (string) return string.split(/\D+/).join("");
    };

    this.validateNewPassword = function (newPassword, confirmPassword, password) {

        if (newPassword != confirmPassword) {
            ScreenService.showMessage(AclMessages.ALE_PASSWORD_NOT_MATCH, "ALERT");
            return false;
        }

        if (password && password === newPassword){
            ScreenService.showMessage(AclMessages.ALE_NEW_PASSWORD_EQUAL_OLD, "ALERT");
            return false;
        }

        return true;
    };
	
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ACLUtilities', ACLUtilities);
});


// FILE: ./assets/js/repositories/Operador.js
var ACLOperadorRepository = function(localStorageEngine, ScreenService) {
    this.retornaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("acl#/crud/operador", filter);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('ACLOperadorRepository', ACLOperadorRepository);
});

// FILE: ./assets/js/repositories/Operator.js
function OperatorRepository(localStorageEngine, ScreenService) {
    
    this.getLoggedOperator = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("acl#/crud/operador", filter);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('OperatorRepository', OperatorRepository);
});

// FILE: ./assets/js/services/AccessProfile.js
function AccessProfileService(requestDataSourceEngine)
{
    
    this.changeAccessProfile = function (row) {
        return requestDataSourceEngine.setDataSource('acl#/changeAccessProfile', [row]);  
    };
    
    this.findAccessControllUtilization = function () {
        return requestDataSourceEngine.getDataSource('acl#/findAccessControllUtilization');  
    };

    this.savePerfAccessParc = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/perfAcessParc', rows);
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('AccessProfileService', AccessProfileService);
});

// FILE: ./assets/js/services/MyProfile.js
function MyProfileService(requestDataSourceEngine) {

    this.changePassword = function (row) {
        return requestDataSourceEngine.setDataSource('acl#/updatePassword', [row]);
    };

    this.uploadProfilePicture = function (row) {
        return requestDataSourceEngine.setDataSource('acl#/uploadProfilePicture', [row]);
    };
    
    this.deleteProfilePicture = function (row) {
        return requestDataSourceEngine.setDataSource('acl#/deleteProfilePicture', [row]);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('MyProfileService', MyProfileService);
});

// FILE: ./assets/js/services/Operator.js
function OperatorService(requestDataSourceEngine, restEngine){
    
    this.getOrganization = function(){
        return requestDataSourceEngine.getDataSource('acl#/findOrganization');
    };
    
    this.saveOperator = function(row){
        return requestDataSourceEngine.setDataSource('acl#/operator', [row]);  
    };
    
    this.saveAccessProfileByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/accessProfileByOperator', rows);  
    };
    
    this.saveRelatedBranchByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/relatedBranchByOperator', rows);  
    };
    
    this.saveRelatedOrganizationByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/relatedOrganizationByOperator', rows);  
    };
    
    this.resetPassword = function(row){
        return requestDataSourceEngine.setDataSource('acl#/resetPassword', [row]);
    };
    
    this.checkIfIsAdm = function(row){
        return restEngine.post('acl#/checkIfIsAdm', {requestType:'Row', row: row});        
    };
    
    this.getOperatorBranches = function(filter){
        return requestDataSourceEngine.getDataSource('acl#/filioperCompleto', filter);        
    };
    
    this.createBusinessPartnership = function(row){
        return requestDataSourceEngine.setDataSource('acl#/createBusinessPartnership', [row]).then(function (response){
            return response.dataset.createBusinessPartnership[0];
        });
    };

    this.getParamGeral = function(){
        return requestDataSourceEngine.getDataSource('acl#/paramGeral');
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('OperatorService', OperatorService);
});

// FILE: ./assets/js/services/SqlLogs.js
function SqlLogsService(requestDataSourceEngine){

    this.findDbUser = function(){
        return requestDataSourceEngine.getDataSource('acl#/findDbUser');
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('SqlLogsService', SqlLogsService);
});

// FILE: ./assets/js/controllers/AccessProfile.js
function AclAccessProfileController(ScreenService, templateManager, localStorageEngine, ZhuAclController,
                                    AclMessages, AccessProfileService, ACLUtilities, ZHPromise, ZhuAclExportRulesController){

	var self = this;
	var ALE_FILL_REQ_FIELD = AclMessages.ALE_FILL_REQ_FIELD;
	var ERR_DEL_PROFILE = AclMessages.ERR_DEL_PROFILE;
	var ERR_SAV_PROFILE = AclMessages.ERR_SAV_PROFILE;
	var ERR_SAV_PROFILE_OPERATORS = AclMessages.ERR_SAV_PROFILE_OPERATORS;
	var CON_DEL_PROFILE = AclMessages.CON_DEL_PROFILE;
	var CON_DEL_PROFILE_OPERATORS = AclMessages.CON_DEL_PROFILE_OPERATORS;
	var SUC_DEL_OPERATOR = AclMessages.SUC_DEL_OPERATOR;
	var CON_CHEN_ACCESS_PROFILE = AclMessages.CON_CHEN_ACCESS_PROFILE;

	self.profileWidgetAfterMoveRow = function() {
		return self.setChildFilters(self.getWidgetProfile());
	};

	self.profileActionEventNew = function() {
		return self.addProfile(self.getWidgetProfile());
	};

	self.profileActionEventEnableAccessControll = function() {
		return self.enableAccessControll();
	};

	self.profileActionEventBack = function() {
		return self.masterDetailBackToList(self.getWidgetProfile());
	};

	self.profileActionEventCancel = function() {
		return self.profileRollback(self.getWidgetProfile());
	};

	self.profileActionEventEdit = function() {
		return self.editProfile(self.getWidgetProfile());
	};

	self.profileActionEventDelete = function() {
		return self.deleteProfileConfirmation(self.getWidgetProfile());
	};

	self.profileActionEventExportRules = function() {
		var profileWidget = self.getWidgetProfile();
		ZhuAclExportRulesController.profileActionEventExportRules(profileWidget.currentRow.NRPERFILACESSO);
	};

	self.profileActionEventSave = function() {
		return self.saveProfile(self.getWidgetProfile());
	};

	self.operatorsWidgetOnEnter = function() {
		return self.getWidgetOperators().reload();
	};

	self.operatorsActionEventNew = function() {
		return self.loadOperators(self.getWidgetOperators());
	};

	self.operatorsActionEventBack = function() {
		return self.masterDetailBackToList(self.getWidgetOperators().parent);
	};

	self.addOperatorActionEventAdd = function(currentWidget) {
		return self.addPerfAcessParc(self.getWidgetAddOperator(), currentWidget);
	};

	self.addOperatorActionEventCancel = function(currentWidget) {
		if(currentWidget && currentWidget.unSelectAll){
			currentWidget.unSelectAll();
		}
		self.getWidgetTabbedChildrenAddOperators().currentRow.DTVALIDADE = '';
		ScreenService.closeSwipe();
	};

	self.getContainerAccessProfile = function(){
		return templateManager.container;
	};

	self.getWidgetProfile = function() {
		return templateManager.container.getWidget('profile');
	};

	self.getWidgetOperators = function() {
		return templateManager.container.getWidget('operators');
	};

	self.getWidgetTabbedChildrenAddOperators = function() {
		return templateManager.container.getWidget('TABBED_CHILDREN_ADD_OPERATOR');
	};

	self.getWidgetAddOperator = function() {
		return templateManager.container.getWidget('addOperator');
	};

	self.getWidgetElements = function() {
		return templateManager.container.getWidget('elements');
	};

	self.getActionViewFromElements = function() {
		return self.getWidgetElements().getAction('view');
	};

	self.getActionEnableAccessProfile = function() {
		return self.getWidgetProfile().getAction('enableAccessProfile');
	};

	self.getActionEditFromElements = function() {
		return self.getWidgetElements().getAction('edit');
	};

	self.setWidgetsVisibility = function (arrayWidgets, visibility) {
		arrayWidgets.forEach(
			function (element) {
				element.isVisible = visibility;
			}
		);
	};

	self.addProfile = function(accessProfileWidget) {
		self.setWidgetsVisibility(accessProfileWidget.widgets, false);
		accessProfileWidget.newRow();
	};

	self.editProfile = function (accessProfileWidget) {
		self.setWidgetsVisibility(accessProfileWidget.widgets, false);
		accessProfileWidget.backupRow = Util.clone(accessProfileWidget.currentRow);
		accessProfileWidget.edit();
	};

	self.profileRollback = function (accessProfileWidget) {
		if (accessProfileWidget.isNewRow()) {
			if (accessProfileWidget.dataSource.data.indexOf(accessProfileWidget.currentRow) !== -1) {
				accessProfileWidget.dataSource.data.pop();
			}
			self.masterDetailBackToList(accessProfileWidget);
		}
		else {
			Util.extend(accessProfileWidget.currentRow, accessProfileWidget.backupRow);
			accessProfileWidget.view();
		}
		self.setWidgetsVisibility(accessProfileWidget.widgets, true);
	};

	self.masterDetailBackToList = function(accessProfileWidget) {
		ScreenService.closeSwipe().then(function() {
			accessProfileWidget.list();
			accessProfileWidget.activate();
		});
	};

	self.deleteProfileConfirmation = function(){
		ScreenService.confirmMessage(
			CON_DEL_PROFILE,
			'ALERT',
			removeProfile
		);
	};

	var removeProfile = function(){
		var accessProfileWidget = self.getWidgetProfile();
		accessProfileWidget.currentRow.__is_new = false;
		accessProfileWidget.removeRow().then(function(){
			ScreenService.closeSwipe();
		}).catch(function (error) {
			ScreenService.errorNotification(ERR_DEL_PROFILE + error.error);
		});
	};

	self.setChildFilters = function (accessProfileWidget) {
		var operatorsWidget = self.getWidgetOperators();
		var groupId = accessProfileWidget.currentRow.NRPERFILACESSO;
		operatorsWidget.dataSourceFilter[0].value = groupId;
        operatorsWidget.reload();
        ZhuAclController.setElementsListFilter(accessProfileWidget.container, groupId);
		accessProfileWidget.activate();
	};

	self.saveProfile = function(accessProfileWidget) {
		if(accessProfileWidget.isValid()) {
			accessProfileWidget.saveRow().then(
				afterSave,
				function(response){
					ScreenService.errorNotification(ERR_SAV_PROFILE + response.data.error);
				}
			);
		}
		else{
			ScreenService.showMessage(ALE_FILL_REQ_FIELD, "", "exclamation");
		}
	};

	function afterSave(response) {
		var accessProfileWidget = self.getWidgetProfile();
		var id = response.dataset.accessProfile[0].NRPERFILACESSO;
		var nrOrg = response.dataset.accessProfile[0].NRORG;
		var operator = response.dataset.accessProfileRowsDefaultValues[0].CDOPERINCLUSAO;
		var createDate = response.dataset.accessProfileRowsDefaultValues[0].DTINCLUSAO;
		self.setWidgetsVisibility(accessProfileWidget.widgets, true);
		accessProfileWidget.currentRow.NRPERFILACESSO = id;
		accessProfileWidget.currentRow.NRORG = nrOrg;
		accessProfileWidget.currentRow.NRORGINCLUSAO = nrOrg;
		accessProfileWidget.currentRow.CDOPERINCLUSAO = operator;
		accessProfileWidget.currentRow.DTINCLUSAO = createDate;
		accessProfileWidget.currentRow.__is_new = false;
		accessProfileWidget.currentRow.changed = false;
		accessProfileWidget.view();
		self.setChildFilters(accessProfileWidget);
	}

	self.loadOperators = function(operatorsWidget) {
		var addOperatorTabbedWidget = operatorsWidget.container.getWidget("TABBED_ADD_OPERATOR");
		var addOperatorTabbedChildrenWidget = operatorsWidget.container.getWidget("TABBED_CHILDREN_ADD_OPERATOR");
		var addOperatorWidget = operatorsWidget.container.getWidget("addOperator");
		var nrParcNegocio = [];
		operatorsWidget.dataSource.data.forEach(function(data){
			nrParcNegocio.push(data.NRPARCNEGOCIO);
		});

		if(nrParcNegocio.length > 0) {
			addOperatorWidget.dataSourceFilter = [{
				"name": "NRPARCNEGOCIO",
				"operator": "NOT IN",
				"value": nrParcNegocio
			}];
		}
		addOperatorWidget.reload();
		ScreenService.openSwipe(addOperatorTabbedWidget).then(function(){
			addOperatorTabbedWidget.edit();
			addOperatorWidget.activate();
		});
	};

	self.addPerfAcessParc = function (widget, currentWidget) {
		var profileWidget = self.getWidgetProfile();
		var operators     = widget.getCheckedRows();
		var addOperatorsTabbedChildrenWidget = self.getWidgetTabbedChildrenAddOperators();

        operators = operators.map(function (element) {
			element.CDTIPOINSCRICAO = getInscriptionType(element.NRINSCRICAOPARC);
            element.NRPERFILACESSO = profileWidget.currentRow.NRPERFILACESSO;
            element.DTVALIDADE = addOperatorsTabbedChildrenWidget.currentRow.DTVALIDADE || null;
            element.__is_new = true;
            element.changed = true;
            return element;
        });

		AccessProfileService.savePerfAccessParc(operators).then(
			finishAddOperators,
			function () {
				ScreenService.errorNotification(ERR_SAV_PROFILE_OPERATORS);
			}
		);

		if(currentWidget && currentWidget.unSelectAll){
			currentWidget.unSelectAll();
		}
	};

	var finishAddOperators = function() {
		var operatorsWidget = self.getWidgetOperators();
		delete(self.getWidgetTabbedChildrenAddOperators().currentRow.DTVALIDADE);
		operatorsWidget.reload();
		ScreenService.closeSwipe();
		operatorsWidget.list();
		operatorsWidget.activate();
	};

	var getInscriptionType = function (inscription) {
		if (inscription) {
			if (inscription.length == 11) {
				return "CPF";
			} else if (inscription.length == 14) {
				return "CNPJ";
			}
		} else {
			return "LIVRE";
		}
	};

	self.getProductId = function() {
		localStorageEngine.getLocalVar("productIdLoginUrl");
	};

    this.accessProfileContainerAfterinit = function() {
        ZhuAclController.insertElementsListWidget(templateManager.container, self.getWidgetProfile(), window.aclExtraElementsFile);

        var loginPromise = localStorageEngine.getLocalVar('loginPromise') || ZHPromise.when();
        ScreenService.showLoader();
        loginPromise.then(function() {
            ScreenService.hideLoader();
            findAccessControllUtilization();
        }).catch(ScreenService.hideLoader);
    };

    this.profileWidgetOnEnter = function(){
        var loginPromise = localStorageEngine.getLocalVar('loginPromise') || ZHPromise.when();
        ScreenService.showLoader();
        loginPromise.then(function() {
            ScreenService.hideLoader();
            var widget = self.getWidgetProfile();
            widget.currentRow = { IDATIVO: "S" };
            ACLUtilities.applyDefaultFilterOnEnter(widget);
        }).catch(ScreenService.hideLoader);
    };

    this.profileFilterAfterApply = function() {
        ACLUtilities.setFilterInit(self.getWidgetProfile());
    };

    this.enableAccessControll = function() {
    	ScreenService.confirmMessage(
			CON_CHEN_ACCESS_PROFILE,
			'question',
			changeAccessControll
		);
	};

    var changeAccessControll = function(){
		var row = {};
		row.IDUTCTRLACESWEB = localStorageEngine.getLocalVar("idutctrlacesweb");
		row.changed = true;
    	AccessProfileService.changeAccessProfile(row).then(function(response){
    		var idutctrlacesweb = response.dataset.changeAccessProfile[0].idutctrlacesweb;
    		var msg = (idutctrlacesweb == 'S') ? AclMessages.SUC_ACCESS_PROFILE_ACTIVATED : AclMessages.SUC_ACCESS_PROFILE_DISABLED ;
    		changeLabelEnableAccessProfile(idutctrlacesweb);
        	localStorageEngine.setLocalVar("idutctrlacesweb", idutctrlacesweb);
        	ScreenService.successNotification(msg);
    	});
    };



    var findAccessControllUtilization = function(){
    	AccessProfileService.findAccessControllUtilization().then(function(response){
    		var idutctrlacesweb;
    		var AccessControllUtilization = response.dataset.findAccessControllUtilization;
    		if (AccessControllUtilization && AccessControllUtilization.length > 0) {
        		idutctrlacesweb = AccessControllUtilization[0].IDUTCTRLACESWEB;
    		} else {
    			idutctrlacesweb = "N";
    		}
        	localStorageEngine.setLocalVar("idutctrlacesweb", idutctrlacesweb);
        	changeLabelEnableAccessProfile(idutctrlacesweb);
        });
    };

    var changeLabelEnableAccessProfile = function (idutctrlacesweb){
    	var actionEnableAccessProfile = self.getActionEnableAccessProfile();
    	var container = self.getContainerAccessProfile();
    	if (idutctrlacesweb == 'N') {
    		container.label = 'Access Profile (Access Control Disabled)';
    		actionEnableAccessProfile.label = 'Enable Access Control';
    	}else{
    		container.label = 'Access Profile';
    		actionEnableAccessProfile.label = 'Disable Access Control';
    	}
    };

    this.operatorsActionEventDelete = function() {
    	ScreenService.confirmMessage(
			CON_DEL_PROFILE_OPERATORS,
			'ALERT',
			deleteOperator
		);
	};

	var deleteOperator = function(){
		var widget = self.getWidgetOperators();
		var row = {};
		row.NRPERFACESSPARC = widget.currentRow.NRPERFACESSPARC;
		row.NRORG = widget.currentRow.NRORG;
		row.__is_new = false;
		row.changed = true;
		widget.dataSource.remove([row]).then(function(data) {
            ScreenService.closeSwipe();
            widget.reload();
            widget.list();
            ScreenService.successNotification(SUC_DEL_OPERATOR);
        }).then(null, function(message) {
            ScreenService.errorNotification(message);
        });
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('AclAccessProfileController', AclAccessProfileController);
});


// FILE: ./assets/js/controllers/MyProfile.js
function MyProfileController(ScreenService, templateManager, ACLUtilities, AclMessages, MyProfileService, LibUtilities) {
    
    /** This code allows the use of the 'debugger' keyword without jslint bothering  */
    /*jshint -W087 */

    /* *******************************************************
    ********************* Get Widgets ***********************
    **********************************************************/

    var getBasicInfoWidget = function () {
        return templateManager.container.getWidget('USER_INFO');
    };

    var getEditPasswordWidget = function () {
        return templateManager.container.getWidget('EDIT_PASSWORD');
    };
    

    /* *******************************************************
    ********************* Get Fields ***********************
    **********************************************************/


    /* *******************************************************
    ******************* USER_INFO  WIDGET ********************
    **********************************************************/

   /* ***************** Widget Events ******************** */

    this.userInfoWidgetAfterLoadDataSource = function () {
        var widget = getBasicInfoWidget();
        widget.moveToFirst();
        if(!widget.currentRow.IMAGE){
            widget.currentRow.IMAGE = './assets/images/user.jpg';
        }
    };

    /* ***************** Actions Events ******************** */
    
    this.basicInfoActionEventEdit = function () {
        var basicInfoWidget = getBasicInfoWidget();
        basicInfoWidget.edit();
        basicInfoWidget.template = basicInfoWidget.templateToForm;
        if(!basicInfoWidget.currentRow.HAS_IMAGE){
            basicInfoWidget.currentRow.IMAGE = '';
        }
    };
    
    this.basicInfoActionEventCancel = function () {
        var basicInfoWidget = getBasicInfoWidget();
        ACLUtilities.genericCancelEvent(basicInfoWidget);
        basicInfoWidget.template = basicInfoWidget.templateToView;
    };
    
    this.basicInfoActionEventOpenPasswordEdit = function () {
        ScreenService.openPopup(getEditPasswordWidget());
    };
    
    this.basicInfoActionEventSave = function () {
        var basicInfoWidget = getBasicInfoWidget();
        if (!basicInfoWidget.currentRow.IMAGE){
            basicInfoWidget.currentRow.changed = true;
            MyProfileService.deleteProfilePicture(basicInfoWidget.currentRow).then(function () {
                reloadAndSetTemplateViewWidget(basicInfoWidget);
            });
        } else {
            MyProfileService.uploadProfilePicture(basicInfoWidget.currentRow).then(function () {
                reloadAndSetTemplateViewWidget(basicInfoWidget);
            });
        }
    };

    var reloadAndSetTemplateViewWidget = function (widget) {
        widget.reload().then(function () {
            templateManager.userData.image = widget.currentRow.IMAGE;
            templateManager.updateTemplate();
            widget.template = widget.templateToView;
            widget.view();
        });
    };
    
    /* *******************************************************
    ***************** EDIT_PASSWORD  WIDGET ******************
    **********************************************************/
   
   /* ***************** Actions Events ******************** */

    this.editPasswordEventSave = function () {
        var editPasswordWidget = getEditPasswordWidget();
        if (editPasswordWidget.isValid()) {
            var password = editPasswordWidget.currentRow.PASSWORD;
            var newPassword = editPasswordWidget.currentRow.NEW_PASSWORD;
            var confirmPassword = editPasswordWidget.currentRow.CONFIRM_PASSWORD;
            if (ACLUtilities.validateNewPassword(newPassword, confirmPassword, password)) {
                MyProfileService.changePassword(editPasswordWidget.currentRow).then(function(){
                    editPasswordWidget.currentRow = {};
                    ScreenService.closePopup();
                    ScreenService.showMessage(AclMessages.SUC_SAVE_PASSWORD);
                }).catch(LibUtilities.showErrorMessage);
            }
        }
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('MyProfileController', MyProfileController);
});

// FILE: ./assets/js/controllers/Operator.js
function OperatorController(ScreenService, OperatorRepository, templateManager, ACLUtilities,
    OperatorService, LibUtilities, AclMessages, localStorageEngine, ZHPromise, General){
    
    var self = this;
    
    /* --------------------------
     *------ Get Widgets ------
     *---------------------------
     */
     
    var getOperatorWidget = function() {
        return templateManager.container.getWidget('OPERATOR');
    };
        
    var getAccessProfileWidget = function() {
        return templateManager.container.getWidget('ACCESS_PROFILE');
    };
    
    var getTabbedAddAccessprofileWidget = function() {
        return templateManager.container.getWidget('TABBED_ADD_ACCESS_PROFILE');
    };

    var getTabbedChildrenAddAccessprofileWidget = function() {
        return templateManager.container.getWidget('TABBED_CHILDREN_ADD_ACCESS_PROFILE');
    };

    var getAddAccessprofileWidget = function() {
        return templateManager.container.getWidget('ADD_ACCESS_PROFILE');
    };

    var getTabbedAddRelatedBranchWidget = function() {
        return templateManager.container.getWidget('TABBED_ADD_RELATED_BRANCH');
    };

    var getTabbedChildrenAddRelatedBranchWidget = function() {
        return templateManager.container.getWidget('TABBED_CHILDREN_ADD_RELATED_BRANCH');
    };

    var getAddRelatedBranchWidget = function() {
        return templateManager.container.getWidget('ADD_RELATED_BRANCH');
    };

    var getAddRelatedOrganizationWidget = function() {
        return templateManager.container.getWidget('ADD_RELATED_ORGANIZATION');
    };
    
    var getEditPasswordWidget = function(){
        return templateManager.container.getWidget('EDIT_PASSWORD');
    };
    
    var getRelatedBranchesWidget = function(){
        return templateManager.container.getWidget('RELATED_BRANCHES');
    };
    
    var getRelatedOrganizationsWidget = function(){
        return templateManager.container.getWidget('RELATED_ORGANIZAIONS');
    };
    /*---------------------------
     *------ Get Fields ---------
     *---------------------------
     */
    
    var getFieldCpfFromOperatorWidget = function() {
        return getOperatorWidget().getField('NRINSCRICAOPARC');
    };
    
    var getFieldOperatorCodeFromOperatorWidget = function() {
        return getOperatorWidget().getField('CDOPERADOR');
    };
    
    var getFieldAccessProfileFromAccessProfileWidget = function() {
        return getOperatorWidget().getField('NMPERFILACESSO');
    };
    
    var getFieldNewPasswordFromOperatorWidget = function(){
        return getOperatorWidget().getField('NEW_PASSWORD');
    };
    
    var getFieldConfirmPasswordFromOperatorWidget = function(){
        return getOperatorWidget().getField('CONFIRM_PASSWORD');
    };
    
    var getFieldAccessNameFromOperatorWidget = function(){
        return getOperatorWidget().getField('NMACESSO');
    };
    
    var getFieldEmailFromOperatorWidget = function(){
        return getOperatorWidget().getField('DSEMAILOPER');
    };

    var getCdFilialFromOperatorWidget = function(){
        return getOperatorWidget().getField('CDFILIAL');
    };

    var getNmOrganizationOperFromOperatorWidget = function(){
        return getOperatorWidget().getField('NMORGANIZACAOOPER');
    };
    
    var getFieldNmEstruturamFromOperatorWidget = function (){
        return getOperatorWidget().getField('NMESTRUTURAM');
    };

    /*-------------------------------------
     *-------- Generic Functions-----------
     *-------------------------------------
     */
    
    var passwordValidate = function(newPassword, confirmPassword){
        if(newPassword != confirmPassword) {
			ScreenService.showMessage(AclMessages.ALE_PASSWORD_NOT_MATCH, "ALERT");
			return false;
        }
		if(newPassword.length < 6 || newPassword.length  > 20) {
			ScreenService.showMessage(AclMessages.ALE_PASSWORD_INVALID_LENGTH, "ALERT");
			return false;
		}
		return true;
    };
    
    var toLowerCase = function(field){
        field.setValue(field.value().toLowerCase());
    };
    
    /*-------------------------------------
     *-------- Operator Widget ------------
     *-------------------------------------
     */
    
    /*---- Operator Widget Events ---------*/
     
    this.operatorWidgetOnEnter = function(args){
        var loginPromise = localStorageEngine.getLocalVar('loginPromise') || ZHPromise.when();
        ScreenService.showLoader();
        loginPromise.then(function() {
            OperatorService.getOrganization().then(function(response){
                if(response && response.dataset){
                    var org = response.dataset.findOrganization[0];
                    localStorageEngine.setLocalVar('organizationId', org.NRORG);
                    localStorageEngine.setLocalVar('organizationName', org.NMORGANIZACAO);
                }
            });
            ScreenService.hideLoader();
            var widget = getOperatorWidget();
            if(widget.calledByBackAction) {
                widget.calledByBackAction = false;
            }
            widget.currentRow = { IDOPERATIVO: 'A' };
            ACLUtilities.applyDefaultFilterOnEnter(widget);
        }).catch(ScreenService.hideLoader);
    };
    
    this.operatorWidgetAfterMoveRow = function(args){
        var widget = getOperatorWidget();
        
        //If current operator doesn't have a business partnership, create it
        if(Util.isEmptyOrBlank(widget.currentRow.NRPARCNEGOCIO) && !widget.currentRow.__is_new) {
            widget.currentRow.CDTIPOINSCRICAO = getInscriptionType(widget.currentRow.NRINSCRICAOPARC);
            widget.currentRow.changed = true;
            OperatorService.createBusinessPartnership(widget.currentRow).then(function (businessPartnership) {
                widget.currentRow.NRPARCNEGOCIO = businessPartnership.NRPARCNEGOCIO;
                widget.currentRow.NMPARCNEGOCIO = businessPartnership.NMPRINCIPALPARC;
                localStorageEngine.setLocalVar('businessPartnership', widget.currentRow.NRPARCNEGOCIO);    
            });
        } else {
            localStorageEngine.setLocalVar('businessPartnership', widget.currentRow.NRPARCNEGOCIO);    
        }
        
        localStorageEngine.setLocalVar('operatorCode', widget.currentRow.CDOPERADOR);
        localStorageEngine.setLocalVar('operatorEmail', widget.currentRow.DSEMAILOPER);
        this.setLoggedOperatorInfos();
        getAccessProfileWidget().reload();
    };
    
    this.operatorWidgetOnEnterOnce = function(args){
        var loginPromise = localStorageEngine.getLocalVar('loginPromise') || ZHPromise.when();
        ScreenService.showLoader();
        loginPromise.then(function() {
            ScreenService.hideLoader();
            self.setOperatorWindowMode(window.showFullOperatorWindow, window.filialRuleInFullOperatorWindow);
        }).catch(ScreenService.hideLoader);
    };

    this.operatorFieldOnChangeCdOperador = function () {
        var widget = getOperatorWidget();
        var codeOperator = widget.currentRow.CDOPERADOR;
        if(!isNaN(codeOperator)){
            var value = General.fill(codeOperator, 12);
            widget.currentRow.CDOPERADOR = value;
        }
    };
    
    /*---- Operator Widget Actions --------*/
    
    this.operatorActionEventBackView = function(args){
        ScreenService.closeSwipe();
        getOperatorWidget().calledByBackAction = true;
    };
    
    this.operatorActionEventCancel = function(args){
        cancelWithoutReloadMasterDetail(getOperatorWidget());
        getFieldOperatorCodeFromOperatorWidget().readOnly = true;
        setInvisibleAndRequiredPasswordField(false);
        setEnableTabWidgetsOperator(true);
        getFieldOperatorCodeFromOperatorWidget().validations = {required: {}};
        getOperatorWidget().cdoperadorValidation = false;
    };
    
    var cancelWithoutReloadMasterDetail = function(widget){
        if(widget.currentRow.__is_new){
            ScreenService.closeSwipe();
            widget.dataSource.data.pop();
        } else {
            widget.dataSource.data.some(function (row, index) {
                if (row.CDOPERADOR == widget.backupRow.CDOPERADOR) {
                    widget.dataSource.data[index] = widget.backupRow;
                    return true;
                }
            });
            widget.currentRow = widget.backupRow;
            widget.view();
        }
    };
    
    this.operatorActionEventAdd = function(args){
        var widget = getOperatorWidget();
        var nmOrganizationOperField = getNmOrganizationOperFromOperatorWidget();
        var operatorCodeField = getFieldOperatorCodeFromOperatorWidget();

        OperatorService.getParamGeral().then(function (response) {
            if(response.dataset.paramgeral[0].IDGERACDOPERADOR === 'S'){
                operatorCodeField.readOnly = true;
                operatorCodeField.validations = {};
                widget.cdoperadorValidation = false;
            } else {
                operatorCodeField.readOnly = false;
                operatorCodeField.validations = {required: {}};
                widget.cdoperadorValidation = true;
            }

            widget.newRow();
            widget.currentRow.NMPAIS = "Brasil";
            widget.currentRow.CDPAIS = "0055";

            nmOrganizationOperField.reload().then(function(data){
                setReadOnlyFieldNmOrganizationOper(data, widget, true);
            });

            setInvisibleAndRequiredPasswordField(true);
            getFieldNmEstruturamFromOperatorWidget().reload();
            OperatorService.getOrganization().then(function(response){
                if(response && response.dataset){
                    var org = response.dataset.findOrganization[0];
                    widget.currentRow.NMORGANIZACAO = org.NMORGANIZACAO;
                }
            });
        });
        this.setLoggedOperatorInfos();
        setEnableTabWidgetsOperator(false);
    };
    
    this.operatorActionEventEdit = function(args){
        var widget = getOperatorWidget();
        var nmOrganizationOperField = getNmOrganizationOperFromOperatorWidget();
        widget.backupRow = Util.clone(widget.currentRow);
        setInvisibleAndRequiredPasswordField(false);
        setEnableTabWidgetsOperator(false);
        nmOrganizationOperField.reload().then(function(data){
            setReadOnlyFieldNmOrganizationOper(data, widget);
            widget.edit();
        });
    };

    var setReadOnlyFieldNmOrganizationOper = function(data, widget, isNew){
        isNew = isNew || false;
        var nmOrganizationOperField = getNmOrganizationOperFromOperatorWidget();
        if(data.dataset.findOrgOper.length < 2){
            if(data.dataset.findOrgOper.length > 0){
                var dataset = data.dataset.findOrgOper[0];
                widget.currentRow.NMORGANIZACAOOPER = dataset.NMORGANIZACAOOPER;
                widget.currentRow.NRORGOPER = dataset.NRORG;
            }
            nmOrganizationOperField.readOnly = true;
        } else {
            nmOrganizationOperField.readOnly = false;
            if (isNew) {
                widget.currentRow.NMORGANIZACAOOPER = localStorageEngine.getLocalVar('organizationName');
                widget.currentRow.NRORGOPER = localStorageEngine.getLocalVar('organizationId');
            }
        }
    };
    
    this.operatorActionEventRemove = function(args){
        ScreenService.confirmMessage(AclMessages.CON_DEL_OPERATOR , 'question', function () {
            ACLUtilities.genericDeleteEvent(getOperatorWidget()).then(function () {
            	ScreenService.successNotification(AclMessages.SUC_DEL_OPERATOR);
            }).catch(LibUtilities.showErrorMessage);
        });
    };

    var validateCodeOperator = function(codeOperator, operatorWidget){
        return codeOperator.length !== 12 && operatorWidget.currentRow.__is_new && operatorWidget.cdoperadorValidation;
    };

    this.operatorActionEventSave = function(args){
        var widget = getOperatorWidget();
        var cpf = ACLUtilities.getOnlyNumberInString(widget.currentRow.NRINSCRICAOPARC);
        var codeOperator = widget.currentRow.CDOPERADOR;
        if (validateCodeOperator(codeOperator, widget)){
            ScreenService.showMessage(AclMessages.ALE_MIN_LENGTH_OPERATOR_CODE);
            return false;
        }
        if (ACLUtilities.checkRequirements(widget) && ACLUtilities.validateCPF(cpf)) {
            
            widget.currentRow.CDTIPOINSCRICAO = getInscriptionType(cpf);
            widget.currentRow.IDOPERATIVO = (widget.currentRow.IDATIVO == 'S') ? 'A' : 'I';
            widget.currentRow.NRINSCRICAOPARC = cpf;
                
            if(!widget.currentRow.__is_new){
                widget.currentRow.OLDNRINSCRICAOPARC = widget.backupRow.NRINSCRICAOPARC;
                widget.currentRow.OLDCDCLIENTE = widget.backupRow.CDCLIENTE;
                widget.currentRow.OLDNMOPERADOR = widget.backupRow.NMOPERADOR;
                widget.currentRow.changed = true;
            }else{
                widget.currentRow.ADMINISTRATOR = widget.ADMINISTRATOR;
                widget.currentRow.BRANCHES = widget.BRANCHES;
            }
            
            OperatorService.saveOperator(widget.currentRow).then(function(response){
                var operatorCode = response.dataset.operator[0].CDOPERADOR;
                    var rowInDataSource = ACLUtilities.getRowInDataSource(widget.dataSource, 'CDOPERADOR', response.dataset.operator[0].CDOPERADOR);
                    widget.view();
                    var filter = [
                        {
                            "name": "CDOPERADOR",
                            "value": operatorCode,
                            "operator": "="
                        }
                    ];
                    
                    ACLUtilities.setDataSourceAfterSave(widget, filter, "CDOPERADOR").then(function(row){
                        widget.setCurrentRow(row);
                        localStorageEngine.setLocalVar('businessPartnership', response.dataset.operator[0].NRPARCNEGOCIO);
                        getFieldOperatorCodeFromOperatorWidget().readOnly = true;
                        widget.currentRow.__is_new = false;
                        setInvisibleAndRequiredPasswordField(false);
                        ScreenService.successNotification(AclMessages.SUC_SAVE_OPERATOR);
                        setEnableTabWidgetsOperator(true);
                        getFieldOperatorCodeFromOperatorWidget().validations = {required: {}};
                        getOperatorWidget().cdoperadorValidation = false;
                    });
                    
            }).catch(LibUtilities.showErrorMessage);
        }
    };
    
    /*------ Operator Widget auxiliary methods ------*/
    
    var setInvisibleAndRequiredPasswordField = function(status){
        if(status){
            getFieldNewPasswordFromOperatorWidget().showOnForm = true;
            getFieldConfirmPasswordFromOperatorWidget().showOnForm = true;
            getFieldNewPasswordFromOperatorWidget().validations = {required: {}};
            getFieldConfirmPasswordFromOperatorWidget().validations = {required: {}};
            
        } else {
            getFieldNewPasswordFromOperatorWidget().showOnForm = false;
            getFieldConfirmPasswordFromOperatorWidget().showOnForm = false;
            getFieldNewPasswordFromOperatorWidget().validations = false;
            getFieldConfirmPasswordFromOperatorWidget().validations = false;
        }
    };
    
    var getInscriptionType = function (inscription) {
        if(inscription) {
            if(inscription.length == 11) {
                return "CPF";
            }else if(inscription.length == 14) {
                return "CNPJ";
            }
        } else {
            return "LIVRE";
        }
    };
    
    this.accessNameFieldFromOperatorWidgetFieldOnChange = function(args){
        toLowerCase(getFieldAccessNameFromOperatorWidget());
    };
    
    this.emailFieldFromOperatorWidgetFieldOnChange = function(args){
        toLowerCase(getFieldEmailFromOperatorWidget());
    };
    
    /**
     *  Use project's 'showFullOperatorWindow' and 'filialRuleInFullOperatorWindow' parameters to
     * set fields and tabs visibility.
     * 
     *  This parameter has to be setted to the 'window' at 'environment.js' as true or false
    */
    this.setOperatorWindowMode = function(showFullOperatorWindow, filialRuleInFullOperatorWindow){
        showFullOperatorWindow         = showFullOperatorWindow         || false;
        filialRuleInFullOperatorWindow = filialRuleInFullOperatorWindow || false;
        var operatorWidget = getOperatorWidget();
        var filialField = getCdFilialFromOperatorWidget();
        
        if(showFullOperatorWindow){
            operatorWidget.COMPLETEMODE = true;
            this.setVisibilityByMode(operatorWidget, true);
            if(filialRuleInFullOperatorWindow){    
                this.checkIfIsAdm().then(function(adm){
                    if(adm === true){
                        operatorWidget.ADMINISTRATOR = true;
                        filialField.filterProperties.isVisible = true;
                        filialField.isVisible = false;
                    }else{
                        this.setOperatorBranchesInOperatorWidget(operatorWidget);
                    }
                }.bind(this)).catch(function(adm){
                    operatorWidget.ADMINISTRATOR = false;    
                    filialField.filterProperties.isVisible = false;
                    filialField.isVisible = false;
                    this.setOperatorBranchesInOperatorWidget(operatorWidget);
                }.bind(this));
            }
        }else{
            operatorWidget.COMPLETEMODE = false;
            this.setVisibilityByMode(operatorWidget, false);
            filialField.filterProperties.isVisible = false;
            filialField.isVisible = false;
        }
        
    };
    
    this.setOperatorBranchesInOperatorWidget = function(widget){
        var filter = [
            {
                "name": "CDOPERADOR",
                "value": localStorageEngine.getLocalVar('userId') || localStorageEngine.getLocalVar('CDOPERADOR'),
                "operator": "="
            }
        ];
        OperatorService.getOperatorBranches(filter).then(function(response){
            if(response && response.dataset.filioperCompleto){
                var branches = response.dataset.filioperCompleto.map(function(branch){return branch.CDFILIAL;});
                widget.BRANCHES = branches;
                
                if(branches.length <= 0) return;
                /* Filter Related Branch tab */
                var branchWidget = getAddRelatedBranchWidget();
                var filterApplied = false;
                branchWidget.dataSourceFilter.forEach(function(filter){
                    if(filter.name === 'CDFILIAL') {
                        filterApplied = true;
                    }
                });
                if(!filterApplied){
                    branchWidget.dataSourceFilter.push({
                        name:"CDFILIAL",
                        operator:"IN",
                        value:branches
                    });
                    getCdFilialFromOperatorWidget().dataSourceFilter.push({
                        name: "CDFILIAL",
                        operator: "IN",
                        value: branches
                    });
                    getOperatorWidget().dataSourceFilter.push({
                        name: "CDFILIAL",
                        operator: "IN",
                        value: branches
                    });
                }
            }    
        });
    };
    
    this.setVisibilityByMode = function(operatorWidget, visible){
        operatorWidget.fields.forEach(function(field){
            if(field.visibleOnlyInCompleteMode === true){
                field.isVisible = visible;
            }
        });
        
        operatorWidget.widgets.forEach(function(widget){
            if(widget.visibleOnlyInCompleteMode === true){
                widget.isVisible = visible;
            }
        });
    };
    
    /**
     * Apply Branch Filter to the widget if the logged operator
     * isn't an administrator
    */
    this.operatorWidgetAfterApply = function(args){
        ACLUtilities.setFilterInit(getOperatorWidget());
        var operatorWidget = getOperatorWidget();
        if(operatorWidget.ADMINISTRATOR === false){
            var filterApplied = false;
            operatorWidget.dataSourceFilter.forEach(function(filter) {
                if(filter.name === 'CDFILIAL') {
                    filterApplied = true;
                }
            });
            if(!filterApplied && operatorWidget.BRANCHES.length > 0){
                operatorWidget.dataSourceFilter.push({
                    name:"CDFILIAL",
                    operator:"IN",
                    value:operatorWidget.BRANCHES
                });
            }
        }
    };
    
    /**
     * Check if the logged operator is Administrator
    */
    this.checkIfIsAdm = function(){
        var promise = ZHPromise.defer();
        var accessProfiles = localStorageEngine.getLocalVar('accessProfiles');
        if(accessProfiles){
            OperatorService.checkIfIsAdm(accessProfiles).then(function(response){ 
                if(response.dataset && response.dataset.administrator){
                    if(response.dataset.administrator[0] === true){
                        promise.resolve(true);
                    }else{
                        promise.resolve(false);    
                    }
                    localStorageEngine.setLocalVar('loggedOperatorNrorg', response.dataset.administrator[1]);
                }else{
                    promise.reject(false);
                }
            });
        }else{
            promise.reject(false);
        }
        return promise.promise;
    };
    
    /**
     *   Set the IDOPERMASTER's readonly based in the Logged Operator
     *  and save some of its infos in the widget to use later
    */
    this.setLoggedOperatorInfos = function(){
        var operatorWidget = getOperatorWidget();
        if(typeof operatorWidget.IDOPERMASTERLOGGED === "undefined"){
            OperatorRepository.getLoggedOperator().then(function(response){
                var operator = response[0];
                if(operator.IDOPERMASTER === 'S'){
                    operatorWidget.getField('IDOPERMASTER').readOnly = false;
                }else{
                    operatorWidget.getField('IDOPERMASTER').readOnly = true;
                }
                operatorWidget.IDOPERMASTERLOGGED = operator.IDOPERMASTER;
                operatorWidget.NRORGTRABLOGGED    = operator.NRORGTRAB;
            });
        }else{
            if(operatorWidget.IDOPERMASTERLOGGED === 'S'){
                operatorWidget.getField('IDOPERMASTER').readOnly = false;
            }else{
                operatorWidget.getField('IDOPERMASTER').readOnly = true;
            }    
        }
    };
    
    /**
     *      Check if the current Organization(relationship) is the Logged Operator's org.
     *  Only in this case he can edit/delete the relationship.
    */
    this.havePermissionToChangeOrg = function(){
        var loggedOrg = getOperatorWidget().NRORGTRABLOGGED;
        if(getRelatedOrganizationsWidget().currentRow.NRORGREL !== loggedOrg){
            ScreenService.showMessage(AclMessages.ALE_PERMISSION_ORGANIZATION);
        }else{
            return true;
        }
    };

    var setEnableTabWidgetsOperator = function(value) {
          var widget = getOperatorWidget();
          widget.widgets.forEach(function (widget){
              widget.enabled = value;
          });
    };
    
    /*-------------------------------------
     *------ Access Profile Widget --------
     *-------------------------------------
     */
     
    /*---- Access profile Widget Actions --------*/
    
    this.accessProfileActionEventBackList = function(args){
        ScreenService.closeSwipe();
    };
    
    this.accessProfileActionEventBackView = function(args){
        ScreenService.closeSwipe();
    };
    
    this.accessProfileActionEventCancel = function(args){
        ACLUtilities.genericCancelEvent(getAccessProfileWidget());
    };
    
    this.accessProfileActionEventAdd = function(args){
        var widget = getAddAccessprofileWidget();
        var tabbedAddAccessProfileWidget = getTabbedAddAccessprofileWidget();
        var tabbedChildrenAddAccessProfileWidget = getTabbedChildrenAddAccessprofileWidget();
        ScreenService.openSwipe(tabbedAddAccessProfileWidget).then(function () {
            tabbedAddAccessProfileWidget.edit();
            widget.activate();
        });
    };
    
    this.accessProfileActionEventEdit = function(args){
        getAccessProfileWidget().edit();  
    };
    
    this.accessProfileActionEventRemove = function(args){
        ScreenService.confirmMessage(AclMessages.CON_DEL_PROFILE , 'question', function () {
            ACLUtilities.genericDeleteEvent(getAccessProfileWidget()).then(function () {
            	ScreenService.successNotification(AclMessages.SUC_DELETE_ACCESS_PROFILE);
            }).catch(LibUtilities.showErrorMessage);
        });
    };
    
    this.accessProfileActionEventSave = function(args){
        var accessProfileWidget = getAccessProfileWidget();
        var currentRow = accessProfileWidget.currentRow;
        currentRow.__is_new = false;
        currentRow.changed = true;
        OperatorService.saveAccessProfileByOperator([currentRow]).then(function(response){
            var partnerAccessProfileNumber = response.dataset.accessProfileByOperator[0].NRPERFACESSPARC;
            ScreenService.successNotification(AclMessages.SUC_SAVE_ACCESS_PROFILE);
            accessProfileWidget.reload().then(function(){
                var rowInDataSource = ACLUtilities.getRowInDataSource(accessProfileWidget.dataSource, 'NRPERFACESSPARC', partnerAccessProfileNumber);
                if(rowInDataSource){
                    accessProfileWidget.setCurrentRow(rowInDataSource);
                    accessProfileWidget.view();
                } else {
                    ScreenService.closeSwipe();
                    accessProfileWidget.list(true);
                }   
            });
        }).catch(LibUtilities.showErrorMessage);
    };
    
    this.openPasswordEdit = function(args){
        ScreenService.openPopup(getEditPasswordWidget());
    };
    
    /*---- Access profile Widget Events --------*/
    
    this.accessProfileWidgetOnEnterTab = function(args){
        getAccessProfileWidget().reload();
    };
    
    /*-------------------------------------
     *---- Add Access Profile Widget ------
     *-------------------------------------
     */
    
    /*---- Add Access profile Widget Actions --------*/
    
    this.addAccessProfileActionEventCancel = function(args){
        getAddAccessprofileWidget().unSelectAll();
        getTabbedChildrenAddAccessprofileWidget().currentRow.DTVALIDADE = '';
        ScreenService.closeSwipe();
    };
    
    this.addAccessProfileActionEventSave = function(args){
        var addAccessprofileWidget = getAddAccessprofileWidget();
        var tabbedChildrenAddAccessprofileWidget = getTabbedChildrenAddAccessprofileWidget();
        var accessProfileWidget = getAccessProfileWidget();
        var checkedRows = addAccessprofileWidget.getCheckedRows();
        checkedRows.forEach(function(element){
            element.NRPARCNEGOCIO = localStorageEngine.getLocalVar('businessPartnership');
            element.DTVALIDADE = tabbedChildrenAddAccessprofileWidget.currentRow.DTVALIDADE || null;
            element.__is_new = true;
            element.changed = true;
        });
        
        OperatorService.saveAccessProfileByOperator(checkedRows).then(function(){
            accessProfileWidget.reload().then(function(){
                addAccessprofileWidget.unSelectAll();
                tabbedChildrenAddAccessprofileWidget.currentRow.DTVALIDADE = '';
                ScreenService.closeSwipe();
                accessProfileWidget.activate();
                ScreenService.successNotification(AclMessages.SUC_SAVE_ACCESS_PROFILE);
            });
        }).catch(LibUtilities.showErrorMessage);
    };
    
    /*---- Add Access profile Widget Events --------*/
    
    this.addAccessProfileWidgetOnEnter = function(){
        getAddAccessprofileWidget().reload();
    };
    
    /*-------------------------------------
     *---- Edit Password Widget ------
     *-------------------------------------
     */
    
    /*---- Edit password Widget Actions --------*/
    
    this.editPasswordActionEventCancel = function(args){
        ScreenService.closePopup(getEditPasswordWidget());
    };
    
    this.editPasswordActionEventSave = function(args){
        var editPasswordWidget = getEditPasswordWidget();
        if(editPasswordWidget.isValid()){
    		var newPassword     = editPasswordWidget.currentRow.NEW_PASSWORD;
    		var confirmPassword = editPasswordWidget.currentRow.CONFIRM_PASSWORD;
    		if(passwordValidate(newPassword, confirmPassword)){
    		    OperatorService.resetPassword(editPasswordWidget.currentRow).then(function(response){
                    ScreenService.successNotification(AclMessages.SUC_SAVE_PASSWORD);
                    ScreenService.closePopup();
			    }).catch(LibUtilities.showErrorMessage);
    		}
        } else {
            ScreenService.showMessage(AclMessages.ALE_FILL_REQ_FIELD);
        }
    };
    
    /*---- Edit password Widget Events --------*/
    
    this.editPasswordWidgetOnEnter = function(args){
        var widget = getEditPasswordWidget();
        widget.newRow();
        widget.currentRow.DSEMAILOPER = localStorageEngine.getLocalVar('operatorEmail');
        widget.currentRow.CDOPERADOR = localStorageEngine.getLocalVar('operatorCode');
    };
    
        
    /*-------------------------------------
     *------ Related Branches Widget --------
     *-------------------------------------
     */
     
    /*---- Related Branches Widget Actions --------*/
    
    this.relatedBranchesActionEventBackList = function(args){
        ScreenService.closeSwipe();
    };
    
    this.relatedBranchesActionEventBackView = function(args){
        ScreenService.closeSwipe();
    };
    
    this.relatedBranchesActionEventCancel = function(args){
        ACLUtilities.genericCancelEvent(getRelatedBranchesWidget());
    };
    
    this.relatedBranchesActionEventAdd = function(args){
        var widget = getAddRelatedBranchWidget();
        var tabbedAddRelatedBranch = getTabbedAddRelatedBranchWidget();
        var tabbedChildrenAddRelatedBranch = getTabbedChildrenAddRelatedBranchWidget();
        widget.reload();
        ScreenService.openSwipe(tabbedAddRelatedBranch).then(function () {
            tabbedAddRelatedBranch.edit();
            widget.activate();
        });
    };
    
    this.relatedBranchesActionEventEdit = function(args){
        getRelatedBranchesWidget().edit();  
    };
    
    this.relatedBranchesActionEventRemove = function(args){
        var widget = getRelatedBranchesWidget();
        ScreenService.confirmMessage(AclMessages.CON_DEL_BRANCH , 'question', function () {
            widget.remove().then(function () {
                ScreenService.successNotification(AclMessages.SUC_DELETE_RELATED_BRANCH);
                ScreenService.closeSwipe().then(function() {
                    widget.reload();
                });
            }).catch(LibUtilities.showErrorMessage);
        });
    };
    
    this.relatedBranchesActionEventSave = function(args){
        var relatedBranchesWidget = getRelatedBranchesWidget();
        var currentRow = relatedBranchesWidget.currentRow;
        currentRow.__is_new = false;
        currentRow.changed = true;
        OperatorService.saveRelatedBranchByOperator([currentRow]).then(function(response){
            var cdfilial = response.dataset.relatedBranchesByOperator[0].CDFILIAL;
            ScreenService.successNotification(AclMessages.SUC_SAVE_RELATED_BRANCH);
            relatedBranchesWidget.reload().then(function(){
                var rowInDataSource = ACLUtilities.getRowInDataSource(relatedBranchesWidget.dataSource, 'CDFILIAL', cdfilial);
                if(rowInDataSource){
                    relatedBranchesWidget.setCurrentRow(rowInDataSource);
                    relatedBranchesWidget.view();
                } else {
                    ScreenService.closeSwipe();
                    relatedBranchesWidget.list(true);
                }   
            });
        }).catch(LibUtilities.showErrorMessage);
    };
    
    /*---- Related Branches Widget Events --------*/
    
    this.relatedBranchesWidgetOnEnterTab = function(args){
        getRelatedBranchesWidget().reload();
    };
    
    /*-------------------------------------
     *---- Add Related Branch Widget ------
     *-------------------------------------
     */
    
    /*---- Add Related Branch Widget Actions --------*/
    
    this.addRelatedBranchActionEventCancel = function(args){
        getAddRelatedBranchWidget().unSelectAll();
        getTabbedChildrenAddRelatedBranchWidget().currentRow.DTVALIDADE = '';
        ScreenService.closeSwipe();
    };
    
    this.addRelatedBranchActionEventSave = function(args){
        var addRelatedBranchWidget = getAddRelatedBranchWidget();
        var tabbedChildrenAddRelatedBranchWidget = getTabbedChildrenAddRelatedBranchWidget();
        var relatedBranchWidget = getRelatedBranchesWidget();
        var checkedRows = addRelatedBranchWidget.getCheckedRows();
        checkedRows.forEach(function(element){
            element.CDOPERADOR = localStorageEngine.getLocalVar('operatorCode');
            element.DTVALIDADE = tabbedChildrenAddRelatedBranchWidget.currentRow.DTVALIDADE || null;
            element.__is_new = true;
            element.changed = true;
        });
        
        OperatorService.saveRelatedBranchByOperator(checkedRows).then(function(){
            relatedBranchWidget.reload().then(function(){
                addRelatedBranchWidget.unSelectAll();
                tabbedChildrenAddRelatedBranchWidget.currentRow.DTVALIDADE = '';
                ScreenService.closeSwipe();
                relatedBranchWidget.activate();
                ScreenService.successNotification(AclMessages.SUC_SAVE_RELATED_BRANCH);
            });
        }).catch(LibUtilities.showErrorMessage);
    };
    
    /*---- Add Related Branch Widget Events --------*/
    
    this.addRelatedBranchWidgetOnEnter = function(){
        getAddRelatedBranchWidget().reload();
    };
    
    /*-------------------------------------
     *------ Related Organizations Widget --------
     *-------------------------------------
     */
     
    /*---- Related Organizations Widget Actions --------*/
    
    this.relatedOrganizationsActionEventBackList = function(args){
        ScreenService.closeSwipe();
    };
    
    this.relatedOrganizationsActionEventBackView = function(args){
        ScreenService.closeSwipe();
    };
    
    this.relatedOrganizationsActionEventCancel = function(args){
        ACLUtilities.genericCancelEvent(getRelatedOrganizationsWidget());
    };
    
    this.relatedOrganizationsActionEventAdd = function(args){
        var widget = getAddRelatedOrganizationWidget();
        ScreenService.openPopup(widget);
    };
    
    this.relatedOrganizationsActionEventEdit = function(args){
        if(this.havePermissionToChangeOrg()){
            getRelatedOrganizationsWidget().edit();  
        }
    };
    
    this.relatedOrganizationsActionEventRemove = function(args){
        if(this.havePermissionToChangeOrg()){
            ScreenService.confirmMessage(AclMessages.CON_DEL_ORGANIZATION , 'question', function () {
                ACLUtilities.genericDeleteEvent(getRelatedOrganizationsWidget()).then(function () {
                	ScreenService.successNotification(AclMessages.SUC_DELETE_RELATED_ORGANIZATION);
                }).catch(LibUtilities.showErrorMessage);
            });
        }
    };
    
    this.relatedOrganizationsActionEventSave = function(args){
        var relatedOrganizationsWidget = getRelatedOrganizationsWidget();
        var currentRow = relatedOrganizationsWidget.currentRow;
        currentRow.__is_new = false;
        currentRow.changed = true;
        OperatorService.saveRelatedOrganizationByOperator([currentRow]).then(function(response){
            var nrorgrel = response.dataset.relatedOrganizationsByOperator[0].NRORGREL;
            ScreenService.successNotification(AclMessages.SUC_SAVE_RELATED_ORGANIZATION);
            relatedOrganizationsWidget.reload().then(function(){
                var rowInDataSource = ACLUtilities.getRowInDataSource(relatedOrganizationsWidget.dataSource, 'NRORGREL', nrorgrel);
                if(rowInDataSource){
                    relatedOrganizationsWidget.setCurrentRow(rowInDataSource);
                    relatedOrganizationsWidget.view();
                } else {
                    ScreenService.closeSwipe();
                    relatedOrganizationsWidget.list(true);
                }   
            });
        }).catch(LibUtilities.showErrorMessage);
    };
    
    /*---- Related Organizations Widget Events --------*/
    
    this.relatedOrganizationsWidgetOnEnterTab = function(args){
        getRelatedOrganizationsWidget().reload();
    };
    
    /*-------------------------------------
     *---- Add Related Organization Widget ------
     *-------------------------------------
     */
    
    /*---- Add Related Organization Widget Actions --------*/
    
    this.addRelatedOrganizationActionEventCancel = function(args){
        getAddRelatedOrganizationWidget().unSelectAll();
        ScreenService.closePopup();        
    };
    
    this.addRelatedOrganizationActionEventSave = function(args){
        var addRelatedOrganizationWidget = getAddRelatedOrganizationWidget();
        var relatedOrganizationWidget = getRelatedOrganizationsWidget();
        var checkedRows = addRelatedOrganizationWidget.getCheckedRows();
        checkedRows.forEach(function(element){
            element.CDOPERADOR = localStorageEngine.getLocalVar('operatorCode');
            element.__is_new = true;
            element.changed = true;
        });
        
        OperatorService.saveRelatedOrganizationByOperator(checkedRows).then(function(){
            relatedOrganizationWidget.reload().then(function(){
                addRelatedOrganizationWidget.unSelectAll();
                ScreenService.closePopup();
                relatedOrganizationWidget.activate();
                ScreenService.successNotification(AclMessages.SUC_SAVE_RELATED_ORGANIZATION);
            });
        }).catch(LibUtilities.showErrorMessage);
    };
    
    /*---- Add Related Organization Widget Events --------*/
    
    this.addRelatedOrganizationWidgetOnEnter = function(){
        getAddRelatedOrganizationWidget().reload();
    };
    
    this.checkshowAutoCadVendedor = function(args){
        args.owner.getWidget('OPERATOR').fieldGroups.forEach(function(group){
            if(group.name == 'SELLER') {
                group.isVisible = window.showAutoCadVendedor;
            }
        });
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('OperatorController', OperatorController);
});

// FILE: ./assets/js/controllers/SqlLogs.js
function SqlLogsController(ScreenService, ACLUtilities, templateManager, ZhFilterPreferences, SqlLogsService) {
    /* --------------------------
     *------ Get Widgets ------
     *---------------------------
     */
    var getSqlLogsWidget = function() {
        return templateManager.container.getWidget('SQL_LOGS_WIDGET');
    };

    this.sqlLogsEventWidgetOnEnter = function () {
        var widget = getSqlLogsWidget();
        if(ACLUtilities.isAppliedFilter(widget)) {
            widget.reload();
        } else {
            SqlLogsService.findDbUser().then(function (response) {
                widget.currentRow.PARSING_SCHEMA_NAME = response.dataset.data[0].DBUSER;
                ZhFilterPreferences.setOriginalFilter(widget.id, widget.currentRow);
                ACLUtilities.applyDefaultFilterOnEnter(widget);
            });
        }
    };
    
    this.sqlLogsEventFilterAfterApply = function() {
        var widget = getSqlLogsWidget();
        ACLUtilities.setFilterInit(widget);
    };

    this.sqlLogsActionEventBack = function() {
        ScreenService.closeSwipe();
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('SqlLogsController', SqlLogsController);
});

