function OperatorService(requestDataSourceEngine, restEngine){
    
    this.getOrganization = function(){
        return requestDataSourceEngine.getDataSource('acl#/findOrganization');
    };
    
    this.saveOperator = function(row){
        return requestDataSourceEngine.setDataSource('acl#/operator', [row]);  
    };
    
    this.saveAccessProfileByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/accessProfileByOperator', rows);  
    };
    
    this.saveRelatedBranchByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/relatedBranchByOperator', rows);  
    };
    
    this.saveRelatedOrganizationByOperator = function(rows){
        return requestDataSourceEngine.setDataSource('acl#/relatedOrganizationByOperator', rows);  
    };
    
    this.resetPassword = function(row){
        return requestDataSourceEngine.setDataSource('acl#/resetPassword', [row]);
    };
    
    this.checkIfIsAdm = function(row){
        return restEngine.post('acl#/checkIfIsAdm', {requestType:'Row', row: row});        
    };
    
    this.getOperatorBranches = function(filter){
        return requestDataSourceEngine.getDataSource('acl#/filioperCompleto', filter);        
    };
    
    this.createBusinessPartnership = function(row){
        return requestDataSourceEngine.setDataSource('acl#/createBusinessPartnership', [row]).then(function (response){
            return response.dataset.createBusinessPartnership[0];
        });
    };

    this.getParamGeral = function(){
        return requestDataSourceEngine.getDataSource('acl#/paramGeral');
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('OperatorService', OperatorService);
});