<?php

namespace Repositories;

use Util\InstanceProvider;

class Operador {
    /**
     * @param $cdOperador
     * @param $nrOrg
     * @return array
     * @throws \Exception
     */
    public function getOperatorParams($cdOperador, $nrOrg){
        $query = "SELECT IDSTATUSENHA
                    FROM OPERADOR
                   WHERE CDOPERADOR = :CDOPERADOR
                     AND NRORG = :NRORG";

        $params = array(
            'CDOPERADOR' => $cdOperador,
            'NRORG' => $nrOrg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        $result = $entityManager->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : $result;
    }

    /**
     * @param $cdOperador
     * @param $nrOrg
     * @param $idStatuSenha
     * @return \Doctrine\DBAL\Driver\Statement
     * @throws \Doctrine\DBAL\DBALException
     */
    public function saveOperatorPasswordStatus($cdOperador, $nrOrg, $idStatuSenha){
        $query = "UPDATE OPERADOR
                     SET IDSTATUSENHA = :IDSTATUSENHA
                   WHERE CDOPERADOR = :CDOPERADOR
                     AND NRORG = :NRORG";

        $params = array(
            'IDSTATUSENHA' => $idStatuSenha,
            'CDOPERADOR' => $cdOperador,
            'NRORG' => $nrOrg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->executeQuery($query, $params);
    }

    /**
     * @param $nrParcNegocio
     * @param $nrOrg
     * @return array
     * @throws \Exception
     */
    public function getOperatorAccessProfile($nrParcNegocio, $nrOrg) {
        $query = "SELECT PP.NRPERFILACESSO AS ID, PA.IDPERFILACESSOADM
                    FROM PERFACESSPARC PP
              INNER JOIN PERFILACESSO PA ON PA.NRPERFILACESSO = PP.NRPERFILACESSO
                   WHERE PP.NRORG = :NRORG
                     AND PP.NRPARCNEGOCIO = :NRPARCNEGOCIO
                     AND PP.IDATIVO = 'S'
                     AND (PP.DTVALIDADE IS NULL OR TRUNC(PP.DTVALIDADE) >= TRUNC(SYSDATE))";

        $params = array(
            'NRPARCNEGOCIO' => $nrParcNegocio,
            'NRORG' => $nrOrg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->fetchAll($query, $params);
    }
}