<?php
namespace Teknisa\Model\Geral\Repositories;


class Tabela extends \Doctrine\ORM\EntityRepository {

    public function getTables($conditions, $startPos, $finalPos){
        $query = <<<SQL
        SELECT *
          FROM (
            SELECT T.*, RowNum rn
            FROM (
                SELECT NMTABELABD AS NAME,
                       DSTABELABD AS DESCRIPTION,
                       IDATIVO AS ACTIVE,
                       DSIDSEQUENCIAL AS SEQUENTIAL
                  FROM TABELA
              ORDER BY NMTABELABD ASC
                ) T
            WHERE 1=1
                  AND RowNum <= :finalPos
                  $conditions)
            WHERE rn >= :startPos
SQL;
        $params = array(
            'startPos' => $startPos,
            'finalPos' => $finalPos
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getAllTables($filter, $startPos, $finalPos){
        $query = <<<SQL
        SELECT  *
        FROM (
            SELECT  table_name, RowNum rn
            FROM    user_tables
            WHERE   TABLE_NAME NOT IN (SELECT NMTABELABD FROM TABELA)
                    $filter
                    AND RowNum <= :finalPos
            ORDER By TABLE_NAME)
        WHERE rn >= :startPos
SQL;
        $params = array(
            'startPos' => $startPos,
            'finalPos' => $finalPos
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getTableByName($tableName, $orgId) {
        $query = <<<SQL
            SELECT *
              FROM TABELA
             WHERE NMTABELABD = :TABLE_NAME
               AND NRORG = :NRORG
SQL;
        $params = array(
            'TABLE_NAME' => $tableName,
            'NRORG' => $orgId
        );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : null;
    }
}