function LSLoginService(requestDataSourceEngine) {
    this.login = function(email, password, attempts) {
        var filter = [ {
            name: 'EMAIL',
            operator: '=',
            value: email
        }, {
            name: 'PASSWORD',
            operator: '=',
            value: password
        }, {
            name: 'PRODUCT_ID',
            operator: '=',
            value: window.projectId
        }, {
            name: 'REQUESTER_URL',
            operator: '=',
            value: document.location.href
        }, {
            name: 'ATTEMPTS',
            operator: '=',
            value: attempts
        } ];

        return requestDataSourceEngine.getDataSource('login#/login', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.requestNewPassword = function(email, style) {
        var filter = [ {
            name: 'EMAIL',
            operator: '=',
            value: email
        }, {
            name: 'STYLE',
            operator: '=',
            value: style
        } ];

        return requestDataSourceEngine.getDataSource('login#/requestNewPassword', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.updatePassword = function(actualPassword, newPassword, newPasswordConfirmation, email) {
        var filter = [ {
            name: 'ACTUAL_PASSWORD',
            operator: '=',
            value: actualPassword
        }, {
            name: 'NEW_PASSWORD',
            operator: '=',
            value: newPassword
        }, {
            name: 'CONFIRM_NEW_PASSWORD',
            operator: '=',
            value: newPasswordConfirmation
        }, {
            name: 'EMAIL',
            operator: '=',
            value: email
        } ];

        return requestDataSourceEngine.getDataSource('login#/updatePassword', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.getProductLanguages = function() {
        var filter = [ {
            name: 'PRODUCT_ID',
            operator: '=',
            value: window.projectId
        } ];

        return requestDataSourceEngine.getDataSource('login#/productLanguages', filter, 1, undefined, undefined, undefined, 120000);
    };

    this.testLicenseConnection = function() {
        return requestDataSourceEngine.getDataSource('login#/testLicenseConnection', [], 1, undefined, undefined, undefined, 120000);
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('LSLoginService', LSLoginService);
});
