<?php

namespace Teknisa\ACL\Repositories;

use Doctrine\DBAL\Connection;

class AccessProfile {

    const QUERY_MAX_NRPERFILACESSO = "SELECT MAX(NRPERFILACESSO) as MAXNRPERFILACESSO FROM PERFILACESSO";

    /** @var Connection */
    protected $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function getMaxNrPerfilAcesso () {
        return $this->connection->fetchAll(self::QUERY_MAX_NRPERFILACESSO);
    }
    
    public function findAccessControllUtilization($nrorg){
        try {
            $query = "SELECT IDUTCTRLACESWEB
                        FROM PARAMGERAL
                       WHERE NRORG = ".$nrorg;
            return $this->connection->fetchAll($query);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    } 
    
    public function changeAccessProfile($nrorg, $idutctrlacesweb){
        try {
            $query = "UPDATE PARAMGERAL SET IDUTCTRLACESWEB = '".$idutctrlacesweb."' WHERE NRORG = ".$nrorg;
            $this->connection->executeQuery($query);
            return $idutctrlacesweb;
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        };
    }
    
    public function insertAccessProfile($nrorg, $idutctrlacesweb, $cdpargeral){
        $insert = "INSERT INTO PARAMGERAL
                              (CDPARGERAL, IDUTCTRLACESWEB, NRORG)
                       VALUES (:CDPARGERAL, :IDUTCTRLACESWEB, :NRORG)";

        $params = array(
            "CDPARGERAL"    =>$cdpargeral,
            "IDUTCTRLACESWEB"  => $idutctrlacesweb,
            "NRORG"         => $nrorg
        );

        try
        {
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        }
        catch(\Exception $e)
        {
            throw new \Exception($e->getMessage());
        };
    }
}